<template>
    <ion-page>
        <ion-header :translucent="true">
            <ion-toolbar>
                <ion-buttons slot="start">
                    <ion-menu-button color="primary"></ion-menu-button>
                </ion-buttons>
                <ion-title>Skupiny zařízení</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content :fullscreen="true">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>
            <ion-segment v-model="filter" v-if="appUser.data.isAdmin">
                <ion-segment-button :value="Device_Group_Filter.My">
                    <ion-label>Moje</ion-label>
                </ion-segment-button>
                <ion-segment-button :value="Device_Group_Filter.All">
                    <ion-label>Všechny</ion-label>
                </ion-segment-button>
            </ion-segment>

            <ion-grid>
                <ion-row>
                    <ion-col class="center">
                        <ion-button
                            @click="createGroup"
                            color="primary"
                            shape="round"
                            ><ion-icon
                                slot="icon-only"
                                :icon="create"
                            ></ion-icon>
                            Vytvořit novou skupinu</ion-button
                        ></ion-col
                    >
                </ion-row>
                <ion-row>
                    <ion-col
                        size="12"
                        size-md="6"
                        size-lg="4"
                        v-for="group in deviceGroupList"
                        :key="group.id"
                    >
                        <group-card
                            :group="group"
                            :appUser="group.owner"
                            @editClick="editGroup"
                            @removeClick="remove"
                    /></ion-col>
                </ion-row>
                <ion-row>
                    <ion-infinite-scroll
                        @ionInfinite="ionInfinite"
                        v-if="result?.deviceGroupList?.pageInfo.hasNextPage"
                    >
                        <ion-infinite-scroll-content
                            loading-text="Prosím počkejte..."
                            loading-spinner="bubbles"
                        ></ion-infinite-scroll-content>
                    </ion-infinite-scroll>
                </ion-row>
            </ion-grid>

            <h2 class="center" v-if="deviceGroupList.length < 1">
                Žádné skupiny
            </h2>
        </ion-content>
    </ion-page>
</template>

<script setup lang="ts">
import { DeviceGroupEdge, Device_Group_Filter } from '@/gql/graphql'
import {
    IonInfiniteScroll,
    IonInfiniteScrollContent,
    InfiniteScrollCustomEvent,
    IonGrid,
    IonRow,
    IonCol,
    IonSegment,
    IonSegmentButton,
    IonLabel,
    IonProgressBar,
    IonContent,
    IonHeader,
    IonMenuButton,
    IonPage,
    IonTitle,
    IonToolbar,
    IonButton,
    IonIcon,
    IonButtons,
} from '@ionic/vue'
import { useMutation, useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed, onUpdated, ref, watch } from 'vue'
import GroupCard from '@/component/Group/GroupCard.vue'
import { useUserStore } from '@/stores/userStore'
import { create } from 'ionicons/icons'
import router from '@/router'
import { Route } from '@/router/route'
import toast from '@/helpers/toast'

const appUser = useUserStore()

const filter = ref(Device_Group_Filter.My)

const { loading, result, refetch, fetchMore } = useQuery(
    gql`
        query deviceGroupList($filter: DEVICE_GROUP_FILTER!, $after: Cursor) {
            deviceGroupList(first: 9, after: $after, filter: $filter) {
                edges {
                    node {
                        id
                        name
                        deviceList {
                            id
                            name
                            ip
                            mac
                        }
                        owner {
                            id
                            name
                        }
                        isActive
                        createdAt
                        updatedAt
                    }
                }
                pageInfo {
                    endCursor
                    hasNextPage
                }
            }
        }
    `,
    {
        filter,
    },
    { fetchPolicy: 'network-only' }
)

watch(filter, () => {
    refetch({
        filter: filter.value,
    })
})

const ionInfinite = (ev: InfiniteScrollCustomEvent) => {
    fetchMore({
        variables: {
            filter: filter.value,
            after: result?.value?.deviceGroupList?.pageInfo.endCursor,
        },
    })
    //generateItems();
    setTimeout(() => ev.target.complete(), 500)
}

onUpdated(() => {
    refetch()
})

const deviceGroupList = computed(() => {
    const edgeList = result?.value?.deviceGroupList?.edges
    return edgeList ? edgeList.map((edge: DeviceGroupEdge) => edge.node) : []
})

const createGroup = () => router.push({ name: Route.group })
const editGroup = (id: string) =>
    router.push({ name: Route.group, params: { id } })

// Smazat

const { mutate: removeDeviceGroup } = useMutation(gql`
    mutation removeDeviceGroup($id: ID!) {
        removeDeviceGroup(id: $id)
    }
`)

const remove = (id: string) =>
    removeDeviceGroup({ id }).then(() => {
        refetch()
        toast(id + ' smazáno', 'success')
    })
</script>
<style>
.center {
    margin-top: 1em;
    text-align: center;
}
</style>
